' Fig. 13.16: ComboBoxTest.vb
' Using ComboBox to select shape to draw.

Public Class FrmComboBox
   Inherits Form

#Region " Windows Form Designer generated code "

   Public Sub New()
      MyBase.New()

      'This call is required by the Windows Form Designer.
      InitializeComponent()

      'Add any initialization after the InitializeComponent() call

   End Sub

   'Form overrides dispose to clean up the component list.
   Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
      If disposing Then
         If Not (components Is Nothing) Then
            components.Dispose()
         End If
      End If
      MyBase.Dispose(disposing)
   End Sub

   ' contains shape list (circle, square, ellipse, pie) 
   Friend WithEvents cboImage As System.Windows.Forms.ComboBox

   'Required by the Windows Form Designer
   Private components As System.ComponentModel.Container

   'NOTE: The following procedure is required by the Windows Form Designer
   'It can be modified using the Windows Form Designer.  
   'Do not modify it using the code editor.
   <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
      Me.cboImage = New System.Windows.Forms.ComboBox()
      Me.SuspendLayout()
      '
      'cboImage
      '
      Me.cboImage.DropDownWidth = 121
      Me.cboImage.Items.AddRange(New Object() {"Circle", "Square", "Ellipse", "Pie", "Filled Circle", "Filled Square", "Filled Ellipse", "Filled Pie"})
      Me.cboImage.Location = New System.Drawing.Point(24, 16)
      Me.cboImage.Name = "cboImage"
      Me.cboImage.Size = New System.Drawing.Size(121, 21)
      Me.cboImage.TabIndex = 0
      '
      'FrmComboBox
      '
      Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
      Me.ClientSize = New System.Drawing.Size(292, 273)
      Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.cboImage})
      Me.Name = "FrmComboBox"
      Me.Text = "ComboBoxTest"
      Me.ResumeLayout(False)

   End Sub

#End Region

   ' get selected index, draw shape
   Private Sub cboImage_SelectedIndexChanged _
      (ByVal sender As System.Object, _
      ByVal e As System.EventArgs) _
      Handles cboImage.SelectedIndexChanged

      ' create graphics object pen, and brush
      Dim myGraphics As Graphics = MyBase.CreateGraphics()

      ' create Pen using color DarkRed
      Dim myPen As New Pen(Color.DarkRed)

      ' create SolidBrush using color DarkRed
      Dim mySolidBrush As New SolidBrush(Color.DarkRed)

      ' clear drawing area by setting it to color White
      myGraphics.Clear(Color.White)

      ' find index, draw proper shape
      Select Case cboImage.SelectedIndex

         Case 0 ' case circle is selected
            myGraphics.DrawEllipse(myPen, 50, 50, 150, 150)

         Case 1 ' case rectangle is selected
            myGraphics.DrawRectangle(myPen, 50, 50, 150, 150)

         Case 2 ' case ellipse is selected
            myGraphics.DrawEllipse(myPen, 50, 85, 150, 115)

         Case 3 ' case pie is selected
            myGraphics.DrawPie(myPen, 50, 50, 150, 150, 0, 45)

         Case 4 ' case filled circle is selected 
            myGraphics.FillEllipse( _
               mySolidBrush, 50, 50, 150, 150)

         Case 5 ' case filled rectangle is selected
            myGraphics.FillRectangle( _
               mySolidBrush, 50, 50, 150, 150)

         Case 6 ' case filled ellipse is selected
            myGraphics.FillEllipse( _
               mySolidBrush, 50, 85, 150, 115)

         Case 7 ' case filled pie is selected
            myGraphics.FillPie( _
               mySolidBrush, 50, 50, 150, 150, 0, 45)

      End Select

   End Sub ' cboImage_SelectedIndexChanged

End Class ' FrmComboBox

' *************************************************************
' * (C) Copyright 2002 by Deitel & Associates, Inc.           *
' *     and Prentice Hall.                                    *
' * All Rights Reserved.                                      *             
' *                                                           *            
' * DISCLAIMER: The authors and publisher of this book have   * 
' * used their best efforts in preparing the book. These      *
' * efforts include the development, research, and testing of *
' * the theories and programs to determine their              * 
' * effectiveness. The authors and publisher make no warranty *
' * of any kind, expressed or implied, with regard to these   *  
' * programs or to the documentation contained in these books.*
' * The authors and publisher shall not be liable in any event*
' * for incidental or consequential damages in connection     *
' * with, or arising out of, the furnishing, performance, or  *
' * use of these programs.                                    * 
' *************************************************************