' TreeViewDirectoryStructure.vb
' Using a TreeView to display the directory structure.

Imports System.IO

Public Class FrmTreeViewDirectory
   Inherits Form

#Region " Windows Form Designer generated code "

   Public Sub New()
      MyBase.New()

      'This call is required by the Windows Form Designer.
      InitializeComponent()

      'Add any initialization after the InitializeComponent() 
      'call

   End Sub

   'Form overrides dispose to clean up the component list.
   Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
      If Disposing Then
         If Not (components Is Nothing) Then
            components.Dispose()
         End If
      End If
      MyBase.Dispose(Disposing)
   End Sub

   ' contains view of c: drive directory structure
   Friend WithEvents treDirectory As System.Windows.Forms.TreeView

   'Required by the Windows Form Designer
   Private components As System.ComponentModel.Container

   'NOTE: The following procedure is required by the Windows Form Designer
   'It can be modified using the Windows Form Designer.  
   'Do not modify it using the code editor.
   <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
      Me.treDirectory = New System.Windows.Forms.TreeView()
      Me.SuspendLayout()
      '
      'treDirectory
      '
      Me.treDirectory.Dock = System.Windows.Forms.DockStyle.Fill
      Me.treDirectory.ImageIndex = -1
      Me.treDirectory.Name = "treDirectory"
      Me.treDirectory.SelectedImageIndex = -1
      Me.treDirectory.Size = New System.Drawing.Size(296, 293)
      Me.treDirectory.TabIndex = 0
      '
      'FrmTreeViewDirectory
      '
      Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
      Me.ClientSize = New System.Drawing.Size(296, 293)
      Me.Controls.AddRange(New System.Windows.Forms.Control() {Me.treDirectory})
      Me.Name = "FrmTreeViewDirectory"
      Me.Text = "TreeViewDirectoryStructure"
      Me.ResumeLayout(False)

   End Sub

#End Region

   ' add all subfolders of 'directoryValue' to 'parentNode'
   Public Sub PopulateTreeView(ByVal directoryValue As String, _
      ByVal parentNode As TreeNode)

      ' populate current node with subdirectories
      Try

         ' get all subfolders
         Dim directoryArray As String() = _
            Directory.GetDirectories(directoryValue)

         If directoryArray.Length <> 0 Then ' if at least one

            Dim currentDirectory As String

            ' for every subdirectory, create new TreeNode, 
            ' add as child of current node and
            ' recursively populate child nodes with subdirectories
            For Each currentDirectory In directoryArray

               ' create TreeNode for current directory
               Dim myNode As TreeNode = _
                  New TreeNode(currentDirectory)

               ' add current directory node to parent node
               parentNode.Nodes.Add(myNode)

               ' recursively populate every subdirectory 
               PopulateTreeView(currentDirectory, myNode)
            Next

         End If

         ' catch exception
      Catch unauthorized As UnauthorizedAccessException
         parentNode.Nodes.Add("Access Denied")
      End Try

   End Sub ' PopulateTreeView

   ' called by system when form loads
   Private Sub FrmTreeViewDirectory_Load(ByVal sender As Object, _
      ByVal e As System.EventArgs) Handles MyBase.Load

      ' add c:\ drive to myTreeView and insert its subfolders
      treDirectory.Nodes.Add("C:")
      PopulateTreeView("C:\", treDirectory.Nodes(0))
   End Sub ' FrmTreeViewDirectory_Load

End Class ' FrmTreeViewDirectory

' *************************************************************
' * (C) Copyright 2002 by Deitel & Associates, Inc.           *
' *     and Prentice Hall.                                    *
' * All Rights Reserved.                                      *
' *                                                           *
' * DISCLAIMER: The authors and publisher of this book have   *
' * used their best efforts in preparing the book. These      *
' * efforts include the development, research, and testing of *
' * the theories and programs to determine their              *
' * effectiveness. The authors and publisher make no warranty *
' * of any kind, expressed or implied, with regard to these   *
' * programs or to the documentation contained in these books.*
' * The authors and publisher shall not be liable in any event*
' * for incidental or consequential damages in connection     *
' * with, or arising out of, the furnishing, performance, or  *
' * use of these programs.                                    *
' *************************************************************