' Fig. 13.39: UsingMDI.vb
' Demonstrating the use of MDI parent and child windows.

Imports System.IO

Public Class FrmUsingMDI
   Inherits System.Windows.Forms.Form

#Region " Windows Form Designer generated code "

   Public Sub New()
      MyBase.New()

      'This call is required by the Windows Form Designer.
      InitializeComponent()

      'Add any initialization after the InitializeComponent() call

   End Sub

   'Form overrides dispose to clean up the component list.
   Protected Overloads Overrides Sub Dispose(ByVal disposing As Boolean)
      If disposing Then
         If Not (components Is Nothing) Then
            components.Dispose()
         End If
      End If
      MyBase.Dispose(disposing)
   End Sub

   ' main menu containing menu items File and Window
   Friend WithEvents mnuMain As MainMenu

   ' menu containing submenu New and menu item Exit
   Friend WithEvents mnuitmFile As MenuItem
   Friend WithEvents mnuitmExit As MenuItem

   ' submenu New
   Friend WithEvents mnuitmNew As MenuItem
   Friend WithEvents mnuitmChild1 As MenuItem
   Friend WithEvents mnuitmChild2 As MenuItem
   Friend WithEvents mnuitmChild3 As MenuItem

   ' menu containing menu items Cascade, TileHorizontal and 
   ' TileVertical
   Friend WithEvents mnuitmWindow As MenuItem
   Friend WithEvents mnuitmCascade As MenuItem
   Friend WithEvents mnuitmTileHorizontal As MenuItem
   Friend WithEvents mnuitmTileVertical As MenuItem
   'Required by the Windows Form Designer
   Private components As System.ComponentModel.Container

   'NOTE: The following procedure is required by the Windows Form Designer
   'It can be modified using the Windows Form Designer.  
   'Do not modify it using the code editor.
   <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()
      Me.mnuitmTileHorizontal = New System.Windows.Forms.MenuItem()
      Me.mnuitmTileVertical = New System.Windows.Forms.MenuItem()
      Me.mnuitmChild1 = New System.Windows.Forms.MenuItem()
      Me.mnuitmCascade = New System.Windows.Forms.MenuItem()
      Me.mnuitmChild2 = New System.Windows.Forms.MenuItem()
      Me.mnuMain = New System.Windows.Forms.MainMenu()
      Me.mnuitmFile = New System.Windows.Forms.MenuItem()
      Me.mnuitmNew = New System.Windows.Forms.MenuItem()
      Me.mnuitmChild3 = New System.Windows.Forms.MenuItem()
      Me.mnuitmExit = New System.Windows.Forms.MenuItem()
      Me.mnuitmWindow = New System.Windows.Forms.MenuItem()
      '
      'mnuitmTileHorizontal
      '
      Me.mnuitmTileHorizontal.Index = 1
      Me.mnuitmTileHorizontal.Text = "Tile Horizontal"
      '
      'mnuitmTileVertical
      '
      Me.mnuitmTileVertical.Index = 2
      Me.mnuitmTileVertical.Text = "Tile Vertical"
      '
      'mnuitmChild1
      '
      Me.mnuitmChild1.Index = 0
      Me.mnuitmChild1.Text = "Child1"
      '
      'mnuitmCascade
      '
      Me.mnuitmCascade.Index = 0
      Me.mnuitmCascade.Text = "Cascade"
      '
      'mnuitmChild2
      '
      Me.mnuitmChild2.Index = 1
      Me.mnuitmChild2.Text = "Child2"
      '
      'mnuMain
      '
      Me.mnuMain.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuitmFile, Me.mnuitmWindow})
      '
      'mnuitmFile
      '
      Me.mnuitmFile.Index = 0
      Me.mnuitmFile.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuitmNew, Me.mnuitmExit})
      Me.mnuitmFile.Text = "File"
      '
      'mnuitmNew
      '
      Me.mnuitmNew.Index = 0
      Me.mnuitmNew.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuitmChild1, Me.mnuitmChild2, Me.mnuitmChild3})
      Me.mnuitmNew.Text = "New"
      '
      'mnuitmChild3
      '
      Me.mnuitmChild3.Index = 2
      Me.mnuitmChild3.Text = "Child3"
      '
      'mnuitmExit
      '
      Me.mnuitmExit.Index = 1
      Me.mnuitmExit.Text = "Exit"
      '
      'mnuitmWindow
      '
      Me.mnuitmWindow.Index = 1
      Me.mnuitmWindow.MdiList = True
      Me.mnuitmWindow.MenuItems.AddRange(New System.Windows.Forms.MenuItem() {Me.mnuitmCascade, Me.mnuitmTileHorizontal, Me.mnuitmTileVertical})
      Me.mnuitmWindow.Text = "Window"
      '
      'FrmUsingMDI
      '
      Me.AutoScaleBaseSize = New System.Drawing.Size(5, 13)
      Me.ClientSize = New System.Drawing.Size(360, 301)
      Me.IsMdiContainer = True
      Me.Menu = Me.mnuMain
      Me.Name = "FrmUsingMDI"
      Me.Text = "UsingMDI"

   End Sub

#End Region
   Private childWindow As FrmChild

   ' create FrmChild1 when menu clicked
   Private Sub mnuitmChild1_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles mnuitmChild1.Click

      ' create image path
      Dim imagePath As String = _
         Directory.GetCurrentDirectory() & "\images\image0.jpg"

      ' create new child
      childWindow = New FrmChild(imagePath, "Child1")
      childWindow.MdiParent = Me  ' set parent
      childWindow.Show()          ' display child
   End Sub ' mnuitmChild1_Click

   ' create FrmChild2 when menu clicked
   Private Sub mnuitmChild2_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles mnuitmChild2.Click

      ' create image path
      Dim imagePath As String = _
         Directory.GetCurrentDirectory() & "\images\image1.jpg"

      ' create new child
      childWindow = New FrmChild(imagePath, "Child2")
      childWindow.MdiParent = Me  ' set parent
      childWindow.Show()          ' display child
   End Sub ' mnuitmChild2_Click

   ' create FrmChild3 when menu clicked
   Private Sub mnuitmChild3_Click( _
      ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles mnuitmChild3.Click

      ' create image path
      Dim imagePath As String = _
         Directory.GetCurrentDirectory() & "\images\image2.jpg"

      ' create new child
      childWindow = New FrmChild(imagePath, "Child3")
      childWindow.MdiParent = Me  ' set parent
      childWindow.Show()          ' display child
   End Sub ' mnuitmChild3_Click

   ' exit application
   Private Sub mnuitmExit_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles mnuitmExit.Click

      Application.Exit()
   End Sub ' mnuitmExit_Click

   ' set cascade layout
   Private Sub mnuitmCascade_Click(ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles mnuitmCascade.Click

      Me.LayoutMdi(MdiLayout.Cascade)
   End Sub ' mnuitmCascade_Click

   ' set TileHorizontal layout
   Private Sub mnuitmTileHorizontal_Click _
      (ByVal sender As System.Object, ByVal e As System.EventArgs) _
      Handles mnuitmTileHorizontal.Click

      Me.LayoutMdi(MdiLayout.TileHorizontal)
   End Sub ' mnuitmTileHorizontal_Click

   ' set TileVertical layout
   Private Sub mnuitmTileVertical_Click _
      (ByVal sender As System.Object, _
      ByVal e As System.EventArgs) Handles mnuitmTileVertical.Click

      Me.LayoutMdi(MdiLayout.TileVertical)
   End Sub ' mnuitmTileVertical_Click

End Class ' FrmUsingMDI

' *************************************************************
' * (C) Copyright 2002 by Deitel & Associates, Inc.           *
' *     and Prentice Hall.                                    *
' * All Rights Reserved.                                      *             
' *                                                           *            
' * DISCLAIMER: The authors and publisher of this book have   * 
' * used their best efforts in preparing the book. These      *
' * efforts include the development, research, and testing of *
' * the theories and programs to determine their              * 
' * effectiveness. The authors and publisher make no warranty *
' * of any kind, expressed or implied, with regard to these   *  
' * programs or to the documentation contained in these books.*
' * The authors and publisher shall not be liable in any event*
' * for incidental or consequential damages in connection     *
' * with, or arising out of, the furnishing, performance, or  *
' * use of these programs.                                    * 
' *************************************************************